From b163b00624ef3fa5cc3a31d62cdb12714cd6831f Mon Sep 17 00:00:00 2001
From: Masahiro Nakamura <tsuucat@icloud.com>
Date: Thu, 19 Dec 2019 00:32:54 +0900
Subject: [PATCH] delete workingText last in insertText

---
 lisp/term/ns-win.el | 3 +--
 src/nsterm.m        | 8 ++++----
 2 files changed, 5 insertions(+), 6 deletions(-)

diff --git a/lisp/term/ns-win.el b/lisp/term/ns-win.el
index 1841e67..1cbe566 100644
--- a/lisp/term/ns-win.el
+++ b/lisp/term/ns-win.el
@@ -317,8 +317,7 @@ ns-insert-working-text
   (ns-delete-working-text)
   (let ((start (point)))
     (insert ns-working-text)
-    (overlay-put (setq ns-working-overlay (make-overlay start (point)
-							(current-buffer) nil t))
+    (overlay-put (setq ns-working-overlay (make-overlay start (point)))
 		 'face 'ns-working-text-face)))
 
 (defun ns-echo-working-text ()
diff --git a/src/nsterm.m b/src/nsterm.m
index 52a9830..c5cc182 100644
--- a/src/nsterm.m
+++ b/src/nsterm.m
@@ -6430,10 +6430,6 @@ - (void)insertText: (id)aString
   if (!emacs_event)
     return;
 
-  /* First, clear any working text.  */
-  if (workingText != nil)
-    [self deleteWorkingText];
-
   /* It might be preferable to use getCharacters:range: below,
      cf. https://developer.apple.com/library/content/documentation/Cocoa/Conceptual/CocoaPerformance/Articles/StringDrawing.html#//apple_ref/doc/uid/TP40001445-112378.
      However, we probably can't use SAFE_NALLOCA here because it might
@@ -6462,6 +6458,10 @@ - (void)insertText: (id)aString
       emacs_event->code = code;
       EV_TRAILER ((id)nil);
     }
+
+  /* Last, clear any working text.  */
+  if (workingText != nil)
+    [self deleteWorkingText];
 }
 
 
-- 
2.21.0

